//redFrik 2013
//released under gnu gpl license

//for nanokontroll

/*
satz1   grob0   grob1   satz0   fein0   fein1   light   eeeuu     -         //knobs
numb0   numb1   numb2   numb3     -       -       -       -       -         //sliders
screw   screw   screw   screw   screw   screw   screw   screw     -         //upper buttons
swiUp   swiUp   swiUp     -       -       -     capa0   capa1   swiOn       //lower buttons
*/


RedThermoKontrollMIDI : RedThermoKontrollTest {
	initRedThermoKontroll {|argMaster|
		super.initRedThermoKontroll(argMaster);
		MIDIIn.connectAll;
		MIDIFunc.cc({|val, ctrl|
			//[ctrl, val].postln;	//debug
			{
				switch(ctrl,
				
					//--sliders
					2, {potNumb0.valueAction= val/127},
					3, {potNumb1.valueAction= val/127},
					4, {potNumb2.valueAction= val/127},
					5, {potNumb3.valueAction= val/127},
					//6, {},
					//8, {},
					//9, {},
					//12, {},
					//13, {},
					
					//--knobs
					14, {potSatz1.valueAction= val/127},
					15, {potGrob0.valueAction= val/127},
					16, {potGrob1.valueAction= val/127},
					17, {potSatz0.valueAction= val/127},
					18, {potFein0.valueAction= val/127},
					19, {potFein1.valueAction= val/127},
					20, {sldLight.valueAction= val/127},
					21, {potEeeuu.valueAction= val/127},
					//22, {},
					
					//--upper buttons
					23, {if(val==127, {butScrew[0].valueAction= 1-butScrew[0].value})},
					24, {if(val==127, {butScrew[1].valueAction= 1-butScrew[1].value})},
					25, {if(val==127, {butScrew[2].valueAction= 1-butScrew[2].value})},
					26, {if(val==127, {butScrew[3].valueAction= 1-butScrew[3].value})},
					27, {if(val==127, {butScrew[4].valueAction= 1-butScrew[4].value})},
					28, {if(val==127, {butScrew[5].valueAction= 1-butScrew[5].value})},
					29, {if(val==127, {butScrew[6].valueAction= 1-butScrew[6].value})},
					30, {if(val==127, {butScrew[7].valueAction= 1-butScrew[7].value})},
					//31, {},
					
					//--lower buttons
					33, {if(val==127, {sldSwiUp.valueAction= 0})},
					34, {if(val==127, {sldSwiUp.valueAction= 0.5})},
					35, {if(val==127, {sldSwiUp.valueAction= 1})},
					//36, {},
					//37, {},
					//38, {},
					39, {if(val==127, {butCapa0.valueAction= 1-butCapa0.value})},
					40, {if(val==127, {butCapa1.valueAction= 1-butCapa1.value})},
					41, {if(val==127, {butSwiOn.valueAction= 1-butSwiOn.value})}
				);
			}.defer;
		});
		this.makeWindow;
	}
}

/*
~kontroll= RedThermoKontrollMIDI.new;
*/
